<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Estilos: Flexbox</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Estilos: Flexbox</h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Introducción</h2>
      <ul class="lista">
        <li>Cajas flexibles</li>
        <li>Requiere una dirección y</li>
        <li>Dos objetos:
          <ul>
            <li>Contenedor (exterior)</li>
            <li>Elementos (hijos del contenedor)</li>
          </ul>
        </li>
      </ul>
      <h3><a href="http://flexboxfroggy.com/#es">Juego</a></h3>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Contenedor</h2>
      <ul class="lista">
        <li>Etiqueta que contendrá los elementos flex</li>
        <li>Para aplicarlo:
          <ul>
            <li><span class="propiedad">display:</span> <span class="valor-css">flex</span>, para contenedor de tipo bloque</li>
            <li><span class="propiedad">display:</span> <span class="valor-css">inline-flex</span>, para contenedor en linea</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-direction</span></h2>
      <ul class="lista">
        <li>Establece la dirección en la que irá metiendo los elementos</li>
        <li>Valores:
          <ul>
            <li><span class="valor-css"><strong>row</strong></span>, en fila (por defecto)</li>
            <li><span class="valor-css">column</span>, en columnas</li>
            <li><span class="valor-css">row-reverse</span>, en fila en dirección opuesta</li>
            <li><span class="valor-css">column-reverse</span>, en columnas en dirección opuesta</li>
          </ul>
        </li>
      </ul>
      <h3><a href="ejemplos/p20_flex_direction.html" target="_blank">Ejemplos</a> <input type="range" onchange="resize(this, 'flex-direction')" min="200" max="600" step="10" value="300"></h3>
      <iframe id="flex-direction" src="ejemplos/p20_flex_direction.html" style="width: 300px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-wrap</span></h2>
      <ul class="lista">
        <li>Establece si los elementos se colocan en una o más líneas</li>
        <li>Valores:
          <ul>
            <li><span class="valor-css"><strong>nowrap</strong></span>, en una sola línea (por defecto)</li>
            <li><span class="valor-css">wrap</span>, de ser necesario crea nuevas lineas</li>
            <li><span class="valor-css">wrap-reverse</span>, como wrap, pero de abajo a arriba</li>
          </ul>
        </li>
      </ul>
      <h3><a href="ejemplos/p20_flex_wrap.html" target="_blank">Ejemplos</a> <input type="range" onchange="resize(this, 'flex-wrap')" min="200" max="600" step="10" value="300"></h3>
      <iframe id="flex-wrap" src="ejemplos/p20_flex_wrap.html" style="width: 300px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-flow</span></h2>
      <ul class="lista">
        <li>Atajo de las dos anteriores</li>
        <li>Da igual el orden (no hay ambigüedad)</li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">justify-content</span></h2>
      <ul class="lista">
        <li>Como repartir los elementos en el eje principal</li>
        <li>Valores:
          <ul>
            <li><span class="valor-css"><strong>flex-start</strong></span>, elementos al inicio (por defecto)</li>
            <li><span class="valor-css">flex-end</span>, elementos al final</li>
            <li><span class="valor-css">center</span>, elementos en el centro</li>
            <li><span class="valor-css">space-between</span>, reparte espacio entre elementos</li>
            <li><span class="valor-css">space-around</span>, reparte espacio entre elementos y extremos</li>
            <li><span class="valor-css">space-evenly</span>, como <span class="valor-css">space-around</span> pero mismo espacio en extemos</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><a href="ejemplos/p20_justify_content.html" target="_blank">Ejemplos</a></h2>
      <iframe src="ejemplos/p20_justify_content.html" style="height: 95%; width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">align-content</span></h2>
      <ul class="lista">
        <li>Como repartir los elementos <strong>multilinea</strong> en el eje secundario</li>
        <li>Valores:
          <ul>
            <li><span class="valor-css">flex-start</span>, elementos al inicio</li>
            <li><span class="valor-css">flex-end</span>, elementos al final</li>
            <li><span class="valor-css">center</span>, elementos en el centro</li>
            <li><span class="valor-css">space-between</span>, reparte espacio entre elementos</li>
            <li><span class="valor-css">space-around</span>, reparte espacio entre elementos y extremos</li>
            <li><span class="valor-css"><strong>stretch</strong></span>, asigna el mismo tamaño a todos los elementos</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><a href="ejemplos/p20_align_content.html" target="_blank">Ejemplos</a></h2>
      <iframe src="ejemplos/p20_align_content.html" style="height: 95%; width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">place-content</span></h2>
      <ul class="lista">
        <li>Atajo de las dos anteriores</li>
        <li>Primer valor para <span class="propiedad">align-content</span> y el segundo para <span class="propiedad">justify-content</span></li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">align-items</span></h2>
      <ul class="lista">
        <li>Como repartir los elementos de <strong>una línea</strong> en el eje secundario</li>
        <li>Valores:
          <ul>
            <li><span class="valor-css">flex-start</span>, elementos al inicio</li>
            <li><span class="valor-css">flex-end</span>, elementos al final</li>
            <li><span class="valor-css">center</span>, elementos en el centro</li>
            <li><span class="valor-css">baseline</span>, elementos en base a la primera línea</li>
            <li><span class="valor-css"><strong>stretch</strong></span>, estira los elementos para que cubra todo el espacio</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><a href="ejemplos/p20_align_items.html" target="_blank">Ejemplos</a></h2>
      <iframe src="ejemplos/p20_align_items.html" style="height: 95%; width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Asignar tamaño a espacios</h2>
      <h3><span class="propiedad">gap</span></h3>
      <ul class="lista">
        <li>Establece la separación tanto para filas como columnas</li>
        <li>Valores:
          <li>Un valor, misma separación para filas y columnas</li>
          <li>Dos valores, el primero para filas y el segundo para columnas</li>
        </li>
      </ul>
      <h3><span class="propiedad">row-gap</span></h3>
      <ul class="lista">
        <li>Establece la separación entre filas</li>
      </ul>
      <h3><span class="propiedad">column-gap</span></h3>
      <ul class="lista">
        <li>Establece la separación entre columnas</li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><a href="ejemplos/p20_flex_espacios.html" target="_blank">Ejemplos</a></h2>
      <iframe src="ejemplos/p20_flex_espacios.html" style="height: 95%; width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">align-self</span></h2>
      <ul class="lista">
        <li>Establece una posición distinta a sus hermanos posicionados con <span class="propiedad">align-items</span></li>
        <li>Valores: 
          <ul>
            <li><span class="valor-css"><strong>auto</strong></span>, hereda de <span class="propiedad">align-items</span> (por defecto)</li>
            <li><span class="valor-css">flex-start</span>, situa el elemento al inicio</li>
            <li><span class="valor-css">flex-end</span>, situa el elemento al final</li>
            <li><span class="valor-css">center</span>, situa el elemento en el centro</li>
            <li><span class="valor-css">baseline</span>, situa el elemento en base a la primera línea</li>
            <li><span class="valor-css">stretch</span>, estira el elemento para que cubra todo el espacio</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><a href="ejemplos/p20_align_self.html" target="_blank">Ejemplos</a></h2>
      <iframe src="ejemplos/p20_align_self.html" style="height: 95%; width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-grow</span></h2>
      <ul class="lista">
        <li>Indica el factor de crecimiento respecto a sus hermanos</li>
        <li>Toma valores enteros</li>
        <li>Por defecto su valor es <span class="valor-css"><strong>0</strong></span></li>
      </ul>
      <h3><a href="ejemplos/p20_flex_grow.html" target="_blank">Ejemplos</a> <input type="range" onchange="resize(this, 'flex-grow')" min="200" max="800" step="10" value="600"></h3>
      <iframe id="flex-grow" src="ejemplos/p20_flex_grow.html" style="width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-shrink</span></h2>
      <ul class="lista">
        <li>Indica el factor de decrecimiento respecto a sus hermanos</li>
        <li>Toma valores enteros</li>
        <li>Por defecto su valor es <span class="valor-css"><strong>1</strong></span></li>
      </ul>
      <h3><a href="ejemplos/p20_flex_shrink.html" target="_blank">Ejemplos</a> <input type="range" onchange="resize(this, 'flex-shrink')" min="200" max="800" step="10" value="600"></h3>
      <iframe id="flex-shrink" src="ejemplos/p20_flex_shrink.html" style="width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex-basis</span></h2>
      <ul class="lista">
        <li>Indica el tamaño inicial del elemento</li>
        <li>Utiliza valores de medida</li>
        <li>Por defecto es <span class="valor-css"><strong>auto</strong></span></li>
      </ul>
      <h3><a href="ejemplos/p20_flex_basis.html" target="_blank">Ejemplos</a> <input type="range" onchange="resize(this, 'flex-basis')" min="200" max="800" step="10" value="600"></h3>
      <iframe id="flex-basis" src="ejemplos/p20_flex_basis.html" style="width: 600px;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">flex</span></h2>
      <ul class="lista">
        <li>Atajo de las tres anteriores</li>
        <li><span class="propiedad">flex-grow</span> <span class="propiedad">flex-shrink</span> <span class="propiedad">flex-basis</span></li>
        <li>Por defecto es <span class="valor-css"><strong>0 1 auto</strong></span></li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">order</span></h2>
      <ul class="lista">
        <li>Establece el orden en el que se posicionan los elementos</li>
        <li>Por defecto es <span class="valor-css">0</span></li>
        <li>Toma valores enteros y permite valores negativos</li>
      </ul>
      <h3><a href="ejemplos/p20_flex_order.html" target="_blank">Ejemplos</a></h3>
      <iframe src="ejemplos/p20_flex_order.html" style="width: 600px;"></iframe>
    </section>

    <section class="no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Partiendo del ejercicio 34</li>
        <li>Quitar los float menos a las imágenes de los pasos</li>
        <li>Conseguir el mismo efecto usando flex
          <ul>
            <li>tanto para el menú</li>
            <li>como con el resultado e ingredientes</li>
          </ul>
        </li>
      </ul>
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/Soluciones/ejercicio34/index.html?inline=false">Index</a>
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/Soluciones/ejercicio34/css/estilo.css?inline=false">Estilo</a>
      </p>
    </section>

  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });

    function resize(control, idContenedor) {
      var x=document.getElementById(idContenedor);  
      x.style.width=control.value + "px";  
    }
  </script>
</body>

</html>